<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
    xmlns="http://www.filemaker.com/fmpxmlresult" xmlns:bf="http://www.chapsoft.com/brushfire/objects" exclude-result-prefixes="bf">
    <xsl:output encoding="UTF-8" method="xml" version="1.0"/>
    <!-- IMPORT BRUSHIFRE OBJECTS Stylesheet written by Russell Kohn
		Chaparral Software & Consulting Services, Inc. 
		www.chapsoft.com  
		
		version 1.0
		May 24, 2004
	-->
    <!-- namespaces used in this stylesheet are:
	
		xsl = standard xslt namespace from w3
		bf = Brushfire grammar
		<none> = FileMaker Pro 6 grammar (FMPXMLRESULT)  
		   
            -->
    <!-- VARIABLES -->
    <!-- recCount : count of records in import file -->
    
    <xsl:variable name="recCount" select="0"/>
    
    
    <xsl:template match="/">
        <FMPXMLRESULT xmlns="http://www.filemaker.com/fmpxmlresult">

            <ERRORCODE>0</ERRORCODE>
            <PRODUCT BUILD="" NAME="" VERSION="" />
            <DATABASE DATEFORMAT="M/d/yyyy" LAYOUT="" NAME="" TIMEFORMAT="h:mm:ss a">
                <xsl:attribute name="RECORDS">
                    <xsl:value-of select="$recCount" />
                </xsl:attribute>
            </DATABASE>
            <METADATA>
				<FIELD EMPTYOK="YES" MAXREPEAT="1" NAME="RefType" TYPE="TEXT" />
				<FIELD EMPTYOK="YES" MAXREPEAT="1" NAME="FileID" TYPE="NUMBER" />
				<FIELD EMPTYOK="YES" MAXREPEAT="1" NAME="FileName" TYPE="TEXT" />
				<FIELD EMPTYOK="YES" MAXREPEAT="1" NAME="ObjectType" TYPE="TEXT" />
				<FIELD EMPTYOK="YES" MAXREPEAT="1" NAME="ObjectName" TYPE="TEXT" />
				<FIELD EMPTYOK="YES" MAXREPEAT="1" NAME="Object_FMID" TYPE="NUMBER" />
				<FIELD EMPTYOK="YES" MAXREPEAT="1" NAME="Object_BFID" TYPE="NUMBER" />
				<FIELD EMPTYOK="YES" MAXREPEAT="1" NAME="Sort" TYPE="TEXT" />
				<FIELD EMPTYOK="YES" MAXREPEAT="1" NAME="Err" TYPE="TEXT" />
				<FIELD EMPTYOK="YES" MAXREPEAT="1" NAME="UsedBy_Count" TYPE="NUMBER" />
				<FIELD EMPTYOK="YES" MAXREPEAT="1" NAME="Uses_Count" TYPE="NUMBER" />
				<FIELD EMPTYOK="YES" MAXREPEAT="1" NAME="Setby_Count" TYPE="NUMBER" />
				<FIELD EMPTYOK="YES" MAXREPEAT="1" NAME="Field_Type" TYPE="TEXT" />
				<FIELD EMPTYOK="YES" MAXREPEAT="1" NAME="Rel_FromFieldID" TYPE="NUMBER" />
				<FIELD EMPTYOK="YES" MAXREPEAT="1" NAME="Rel_FromFieldName" TYPE="TEXT" />
				<FIELD EMPTYOK="YES" MAXREPEAT="1" NAME="Rel_ToFileID" TYPE="NUMBER" />
				<FIELD EMPTYOK="YES" MAXREPEAT="1" NAME="Rel_ToFileName" TYPE="TEXT" />
				<FIELD EMPTYOK="YES" MAXREPEAT="1" NAME="Rel_ToFieldID" TYPE="NUMBER" />
				<FIELD EMPTYOK="YES" MAXREPEAT="1" NAME="Rel_ToFieldName" TYPE="TEXT" />
				<FIELD EMPTYOK="YES" MAXREPEAT="1" NAME="ErrorCode" TYPE="TEXT" />
				<FIELD EMPTYOK="YES" MAXREPEAT="1" NAME="Error_Description" TYPE="TEXT" />
				<FIELD EMPTYOK="YES" MAXREPEAT="1" NAME="search_URL" TYPE="TEXT" />
			</METADATA>
            
            <RESULTSET>
                <xsl:attribute name="FOUND">
                    <xsl:value-of select="$recCount"/>
                </xsl:attribute>
                
               <xsl:call-template name="import_BFfields"/>
               <xsl:call-template name="import_BFrelationships"/>
               <xsl:call-template name="import_BFlayouts"/>
               <xsl:call-template name="import_BFScripts"/>
              

            </RESULTSET>
            
        </FMPXMLRESULT>
    </xsl:template>
    
     <xsl:template name="import_BFfields">
        <xsl:for-each select="./bf:brushfire_objects/bf:file/bf:fields/bf:field">
            <ROW>
                <xsl:attribute name="MODID">0</xsl:attribute>
                <xsl:attribute name="RECORDID">0</xsl:attribute>
                
				<!-- RefType -->
				<COL><DATA>
					<xsl:value-of select="'Field'"/>
				</DATA></COL>
				
				<!-- File BF ID -->
				<COL><DATA>
					<xsl:value-of select="../../@bfid"/>
				</DATA></COL>
				
				<!-- FileName -->
				<COL><DATA>
					<xsl:value-of select="../../@name"/>
				</DATA></COL>
				
				<!-- ObjectType -->
				<COL><DATA>
					<xsl:value-of select="'Field'"/>
				</DATA></COL>

				<!-- Field Name (ObjectName) -->
				<COL><DATA>
					<xsl:value-of select="bf:name"/>
				</DATA></COL>
				
				<!-- Field FM ID (Object_FMID) -->
				<COL><DATA>
					<xsl:value-of select="@id"/>
				</DATA></COL>
				
				<!-- Field BF ID (Object_BFID) -->
				<COL><DATA>
					<xsl:value-of select="@bfid"/>
				</DATA></COL>
				
				<!-- Sort -->
				<COL><DATA>
					<xsl:value-of select="bf:sort"/>
				</DATA></COL>
				
				<!-- Err -->
				<COL><DATA>
					<xsl:value-of select="bf:err"/>
				</DATA></COL>
				
				<!-- UsedBy_Count -->
				<COL><DATA>
					<xsl:value-of select="bf:usedby"/>
				</DATA></COL>
				
				<!-- Uses_Count -->
				<COL><DATA>
					<xsl:value-of select="bf:uses"/>
				</DATA></COL>
				
				<!-- Setby_Count -->
				<COL><DATA>
					<xsl:value-of select="bf:setby"/>
				</DATA></COL>	
				
				<!-- Field_Type -->
				<COL><DATA>
					<xsl:value-of select="bf:type"/>
				</DATA></COL>
					
				<!-- nine additional empty fields -->
				<COL><DATA></DATA></COL>
				<COL><DATA></DATA></COL>
				<COL><DATA></DATA></COL>
				<COL><DATA></DATA></COL>
				<COL><DATA></DATA></COL>
				<COL><DATA></DATA></COL>
				<COL><DATA></DATA></COL>
				<COL><DATA></DATA></COL>
				<COL><DATA></DATA></COL>
				
            </ROW>
        </xsl:for-each>
    </xsl:template>
    
    <xsl:template name="import_BFrelationships">
        <xsl:for-each select="./bf:brushfire_objects/bf:file/bf:relations/bf:rel">
            <ROW>
                <xsl:attribute name="MODID">0</xsl:attribute>
                <xsl:attribute name="RECORDID">0</xsl:attribute>
                
				<!-- RefType -->
				<COL><DATA>
					<xsl:value-of select="'Relation'"/>
				</DATA></COL>
				
				<!-- File BF ID -->
				<COL><DATA>
					<xsl:value-of select="../../@bfid"/>
				</DATA></COL>
				
				<!-- FileName -->
				<COL><DATA>
					<xsl:value-of select="../../@name"/>
				</DATA></COL>
				
				<!-- ObjectType -->
				<COL><DATA>
					<xsl:value-of select="'Relation'"/>
				</DATA></COL>

				<!-- Relation Name (ObjectName) -->
				<COL><DATA>
					<xsl:value-of select="bf:name"/>
				</DATA></COL>
				
				<!-- Relation FM ID (Object_FMID) -->
				<COL><DATA>
					<xsl:value-of select="@id"/>
				</DATA></COL>
				
				<!-- Relation BF ID (Object_BFID) -->
				<COL><DATA>
					<xsl:value-of select="@bfid"/>
				</DATA></COL>
				
				<!-- Sort -->
				<COL><DATA>
					<xsl:value-of select="bf:sort"/>
				</DATA></COL>
				
				<!-- Err -->
				<COL><DATA>
					<xsl:value-of select="bf:err"/>
				</DATA></COL>
				
				<!-- UsedBy_Count -->
				<COL><DATA>
					<xsl:value-of select="bf:usedby"/>
				</DATA></COL>
				
				<!-- Uses_Count (not used by relations)-->
				<COL><DATA></DATA></COL>
				
				<!-- Setby_Count (not used by relations)-->
				<COL><DATA></DATA></COL>	
				
				<!-- Field_Type (not used by relations) -->
				<COL><DATA></DATA></COL>
				
				<!-- Rel_FromFieldID -->
				<COL><DATA>
					<xsl:value-of select="bf:fromfield_id"/>
				</DATA></COL>
				
				<!-- Rel_FromFieldName -->
				<COL><DATA>
					<xsl:value-of select="bf:fromfieldname"/>
				</DATA></COL>
				
				<!-- Rel_ToFileID -->
				<COL><DATA>
					<xsl:value-of select="bf:tofile"/>
				</DATA></COL>
				
				<!-- Rel_ToFileName -->
				<COL><DATA>
					<xsl:value-of select="bf:tofilename"/>
				</DATA></COL>
				
				<!-- Rel_ToFieldID -->
				<COL><DATA>
					<xsl:value-of select="bf:tofieldid"/>
				</DATA></COL>
				
				<!-- Rel_ToFieldName -->
				<COL><DATA>
					<xsl:value-of select="bf:tofieldname"/>
				</DATA></COL>
				
				<!-- Errorcode, Errorescription, URL import (not used) -->
				<COL><DATA></DATA></COL>
				<COL><DATA></DATA></COL>
				<COL><DATA></DATA></COL>
				
            </ROW>
        </xsl:for-each>
    </xsl:template>
    
    
     <xsl:template name="import_BFlayouts">
        <xsl:for-each select="./bf:brushfire_objects/bf:file/bf:layouts/bf:layout">
            <ROW>
                <xsl:attribute name="MODID">0</xsl:attribute>
                <xsl:attribute name="RECORDID">0</xsl:attribute>
                
				<!-- RefType -->
				<COL><DATA>
					<xsl:value-of select="'Layout'"/>
				</DATA></COL>
						
				<!-- File BF ID -->
				<COL><DATA>
					<xsl:value-of select="../../@bfid"/>
				</DATA></COL>
				
				<!-- FileName -->
				<COL><DATA>
					<xsl:value-of select="../../@name"/>
				</DATA></COL>
				
				<!-- ObjectType -->
				<COL><DATA>
					<xsl:value-of select="'Layout'"/>
				</DATA></COL>

				<!-- Layout Name (ObjectName) -->
				<COL><DATA>
					<xsl:value-of select="bf:name"/>
				</DATA></COL>
				
				<!-- Layout FM ID (Object_FMID) -->
				<COL><DATA>
					<xsl:value-of select="@id"/>
				</DATA></COL>
				
				<!-- Layout BF ID (Object_BFID) -->
				<COL><DATA>
					<xsl:value-of select="@bfid"/>
				</DATA></COL>
				
				<!-- Sort -->
				<COL><DATA>
					<xsl:value-of select="bf:sort"/>
				</DATA></COL>
				
				<!-- Err -->
				<COL><DATA>
					<xsl:value-of select="bf:err"/>
				</DATA></COL>
				
				<!-- UsedBy_Count -->
				<COL><DATA>
					<xsl:value-of select="bf:usedby"/>
				</DATA></COL>
				
				<!-- Uses_Count -->
				<COL><DATA>
					<xsl:value-of select="bf:uses"/>
				</DATA></COL>
				
				<!-- Setby_Count (not used by layouts) -->
				<COL><DATA></DATA></COL>
				
				
				<!-- Field_Type  (not used by layouts)-->
				<COL><DATA></DATA></COL>
				
				
				<!-- nine additional empty fields -->
				<COL><DATA></DATA></COL>
				<COL><DATA></DATA></COL>
				<COL><DATA></DATA></COL>
				<COL><DATA></DATA></COL>
				<COL><DATA></DATA></COL>
				<COL><DATA></DATA></COL>
				<COL><DATA></DATA></COL>
				<COL><DATA></DATA></COL>
				<COL><DATA></DATA></COL>
				
			</ROW>
		</xsl:for-each>
	</xsl:template>
 
    
    <xsl:template name="import_BFScripts">
        <xsl:for-each select="./bf:brushfire_objects/bf:file/bf:scripts/bf:script">
            <ROW>
                <xsl:attribute name="MODID">0</xsl:attribute>
                <xsl:attribute name="RECORDID">0</xsl:attribute>
                
                <xsl:variable name="isSeparator" select="@separator"/>
                
				<!-- RefType -->
				<COL><DATA>
					<xsl:value-of select="'Script'"/>
				</DATA></COL>
				
				<!-- File BF ID -->
				<COL><DATA>
					<xsl:value-of select="../../@bfid"/>
				</DATA></COL>
					
				<!-- FileName -->
				<COL><DATA>
					<xsl:value-of select="../../@name"/>
				</DATA></COL>
				
				<!-- ObjectType -->
				<COL><DATA>
					<xsl:value-of select="'Script'"/>
				</DATA></COL>

				<xsl:choose>
				
                	<xsl:when test="($isSeparator = 'yes')">
                		<!-- Script Name (ObjectName) -->
						<COL><DATA><xsl:text>-</xsl:text></DATA></COL>		
						<!-- 7 additional script fields that are empty for separators -->
						<COL><DATA></DATA></COL>
						<COL><DATA></DATA></COL>
						<COL><DATA></DATA></COL>
						<COL><DATA></DATA></COL>
						<COL><DATA></DATA></COL>
						<COL><DATA></DATA></COL>
						<COL><DATA></DATA></COL>
                	</xsl:when>
                	
                	<xsl:otherwise>
						<!-- Script Name (ObjectName) -->
						<COL><DATA>
							<xsl:value-of select="bf:name"/>
						</DATA></COL>
					
						<!-- Script FM ID (Object_FMID) -->
						<COL><DATA>
							<xsl:value-of select="@id"/>
						</DATA></COL>
				
						<!-- Script BF ID (Object_BFID) -->
						<COL><DATA>
							<xsl:value-of select="@bfid"/>
						</DATA></COL>
				
						<!-- Sort -->
						<COL><DATA>
							<xsl:value-of select="bf:sort"/>
						</DATA></COL>
				
						<!-- Err -->
						<COL><DATA>
							<xsl:value-of select="bf:err"/>
						</DATA></COL>
				
						<!-- UsedBy_Count -->
						<COL><DATA>
							<xsl:value-of select="bf:usedby"/>
						</DATA></COL>
				
						<!-- Uses_Count -->
						<COL><DATA>
							<xsl:value-of select="bf:uses"/>
						</DATA></COL>
				
						<!-- Setby_Count (this is actually the count of fields set by this script-->
						<COL><DATA>
							<xsl:value-of select="bf:sets"/>
						</DATA></COL>
					</xsl:otherwise>
					
				</xsl:choose>
				
				<!-- Field_Type  (not used)-->
				<COL><DATA></DATA></COL>
				
				<!-- nine additional empty fields -->
				<COL><DATA></DATA></COL>
				<COL><DATA></DATA></COL>
				<COL><DATA></DATA></COL>
				<COL><DATA></DATA></COL>
				<COL><DATA></DATA></COL>
				<COL><DATA></DATA></COL>
				<COL><DATA></DATA></COL>
				<COL><DATA></DATA></COL>
				<COL><DATA></DATA></COL>
				
			</ROW>
		</xsl:for-each>
	</xsl:template>
    
    
    
    
</xsl:stylesheet>
